#ifndef _LIBDOO_ERROR_HANDLING_
#define _LIBDOO_ERROR_HANDLING_

#include <stdint.h>

#include <cstdarg>
#include <cstdio>
#include <cstdlib>

namespace diva
{
namespace imgproc
{

#ifndef DOO_ERRORDEF
#define DOO_ERRORDEF
void ErrorImg(const char *message, ...);

inline void ErrorImg(const char *message, ...)
{
#ifdef LINUX
    va_list ap;

    fflush(stdout);
    va_start(ap, message);
    fprintf(stderr, "ERROR: ");
    vfprintf(stderr, message, ap);
    va_end(ap);
    fprintf(stderr, "\n\n");
    fflush(stderr);
    exit(EXIT_FAILURE);
#endif //def LINUX
}

#endif //ndef DOO_ERRORDEF
}

}
#endif //ndef _LIBDOO_ERROR_HANDLING
