#ifndef _DOO_MINIMUM_SPANNING_TREES_H_
#define _DOO_MINIMUM_SPANNING_TREES_H_

#include "igeom.h"
#include "image.h"

#include <vector>

namespace diva
{

namespace imgproc
{

/*!\defgroup MST Minimum Spanning Trees
 * \brief Include header file(s): <doolib/imst.h>
 */

//!\addtogroup MST
//@{
/*!Class representing a weighted graph edge.
 */
class WeightedEdge
{
public:
    unsigned int org;        //!<index or id of the origin vertex
    unsigned int dest;        //!<index or id of the destination vertex
    double weight;            //!<weight associated to the edge

    WeightedEdge() :
            org(0), dest(0), weight(0)
    {
    }

    WeightedEdge(unsigned int o, unsigned int d, double w) :
            org(o), dest(d), weight(w)
    {
    }
};

std::vector<WeightedEdge>* Euclidean_MST(const std::vector<Point2D<double> >& sites);
//@}

//--------------------------------------------------------------------------------
//                         IMPLEMENTATIONS of INLINE/ TEMPLATE functions
//--------------------------------------------------------------------------------

}//namespace

}

#endif //_DOO_MINIMUM_SPANNING_TREES_H_
